/*-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/*/
/*-					       -*/
/*-     ___       ___       ___       ___      -*/
/*-    /\  \     /\__\     /\  \     /\  \     -*/
/*-   /::\  \   /:| _|_   _\:\  \   /::\  \    -*/
/*-  /::\:\__\ /::|/\__\ /\/::\__\ /:/\:\__\   -*/
/*-  \;:::/  / \/|::/  / \::/\/__/ \:\/:/  /   -*/
/*-   |:\/__/    |:/  /   \:\__\    \::/  /    -*/
/*-    \|__|     \/__/     \/__/     \/__/     -*/
/*-					       -*/
/*-  - RedKod NetWork Informations Displayer - -*/
/*-           http://www.redkod.com/           -*/
/*-					       -*/
/*- Coder : R-e-D			       -*/
/*- Mail  : r-e-d@redkod.com		       -*/
/*-					       -*/
/*-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "netinfos.h"
#include "config.h"
#include "statistics.h"
#include "tables.h"


#pragma comment(lib, "Iphlpapi.lib")
#pragma comment(lib, "wsock32.lib")

int main(int argc, char **argv)
{		
	if(argc < 2)
	{
		fprintf(stdout, "Usage : \n");
		fprintf(stdout, "	Network Informations 		-n\n");
		fprintf(stdout, "	Interfaces Informations 	-i\n");
		fprintf(stdout, "	Protocol Statistics 		-t [ip|tcp|udp|icmp]\n");
		fprintf(stdout, "	Protocol connexions table 	-c [tcp|udp]\n");
		fprintf(stdout, "	Display interface to IP address\n\tmapping table :\t\t\t-m\n");
		fprintf(stdout, "	Display IP routing table	-r\n");
		fprintf(stdout, "	Set TTL for the computer	-t [TTL]\n");
		return(-1);
	}

	/* Fuck getopt :) */

	if(!strcmp(argv[1], "-t"))
		SetTTL(atoi(argv[2]));

	if(!strcmp(argv[1], "-n"))
		GetAndDisplayNetworkInfos();

	if(!strcmp(argv[1], "-i"))
		GetAndDisplayInterfaceInfos();		

	if(!strcmp(argv[1], "-t"))
	{
		if(!strcmp(argv[2], "ip"))
			GetAndDisplayIpStatistics();						
		if(!strcmp(argv[2], "tcp"))
			GetAndDisplayTcpStatistics();
		if(!strcmp(argv[2], "udp"))
			GetAndDisplayUdpStatistics();
		if(!strcmp(argv[2], "icmp"))
			GetAndDisplayIcmpStatistics();
	}

	if(!strcmp(argv[1], "-c"))
	{
		if(!strcmp(argv[2], "tcp"))
			GetAndDisplayTcpTable();
		if(!strcmp(argv[2], "udp"))
			GetAndDisplayUdpTable();
	}

	if(!strcmp(argv[1], "-m"))
		GetAndDisplayIpAddrTable();

	if(!strcmp(argv[1], "-r"))
		GetAndDisplayIpForwardTable();

	return(0);
}