/*-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/*/
/*-					       -*/
/*-     ___       ___       ___       ___      -*/
/*-    /\  \     /\__\     /\  \     /\  \     -*/
/*-   /::\  \   /:| _|_   _\:\  \   /::\  \    -*/
/*-  /::\:\__\ /::|/\__\ /\/::\__\ /:/\:\__\   -*/
/*-  \;:::/  / \/|::/  / \::/\/__/ \:\/:/  /   -*/
/*-   |:\/__/    |:/  /   \:\__\    \::/  /    -*/
/*-    \|__|     \/__/     \/__/     \/__/     -*/
/*-					       -*/
/*-  - RedKod NetWork Informations Displayer - -*/
/*-           http://www.redkod.com/           -*/
/*-					       -*/
/*- Coder : R-e-D			       -*/
/*- Mail  : r-e-d@redkod.com		       -*/
/*-					       -*/
/*-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/-/*/

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>

#include <iphlpapi.h>


char *DisplayTcpState(DWORD dwState)
{
	switch(dwState)
	{
	case MIB_TCP_STATE_CLOSED:
		return("CLOSED");
		break;
	case MIB_TCP_STATE_LISTEN:
		return("LISTEN");
		break;
	case MIB_TCP_STATE_SYN_SENT:
		return("SYN_SENT");
		break;
	case MIB_TCP_STATE_SYN_RCVD:
		return("SYN_RCVD");
		break;
	case MIB_TCP_STATE_ESTAB:
		return("ESTABLISHED");
		break;
	case MIB_TCP_STATE_FIN_WAIT1:
		return("FIN_WAIT1");
		break;
	case MIB_TCP_STATE_FIN_WAIT2:
		return("FIN_WAIT2");
		break;
	case MIB_TCP_STATE_CLOSE_WAIT:
		return("CLOSE_WAIT");
		break;
	case MIB_TCP_STATE_CLOSING:
		return("CLOSING");
		break;
	case MIB_TCP_STATE_LAST_ACK:
		return("LAST_ACK");
		break;
	case MIB_TCP_STATE_TIME_WAIT:
		return("TIME_WAI");
		break;
	case MIB_TCP_STATE_DELETE_TCB:
		return("DELETE_TCB");
		break;
		
	}
	return(NULL);
}
		
int GetAndDisplayTcpTable(void)
{
	PMIB_TCPTABLE TcpTable;
	unsigned long pdwSize;
	unsigned int i, local_port, dest_port;
	unsigned char *p = NULL, *local_ip = NULL, *dest_ip = NULL;
	char *buffer = NULL;

	pdwSize = GetTcpTable(NULL, &pdwSize, TRUE);
	pdwSize = (pdwSize + 1) * sizeof(MIB_TCPTABLE) ;
	TcpTable = (PMIB_TCPTABLE)malloc(pdwSize * sizeof(TcpTable));

	if(GetTcpTable(TcpTable, &pdwSize, TRUE) == NO_ERROR)
	{
		fprintf(stdout, "========================\n");
		fprintf(stdout, "= TCP Connexions Table =\n");
		fprintf(stdout, "========================\n\n");
		fprintf(stdout, "=> Number of entries : %d\n\n", TcpTable->dwNumEntries);
		
		fprintf(stdout, "=====================================================================\n");
		fprintf(stdout, "   Local Address  Local Port\tRemote Address\tRemote Port\tState\n");
		fprintf(stdout, "=====================================================================\n\n");

		for(i=0; i < TcpTable->dwNumEntries; i++)
		{
			local_ip = (unsigned char *)&(TcpTable->table[i].dwLocalAddr);
			p = (unsigned char * )&(TcpTable->table[i].dwLocalPort);
			local_port = *(p+0)*256 + *(p+1);
		
			dest_ip = (unsigned char *)&(TcpTable->table[i].dwRemoteAddr);
			p = (unsigned char * )&(TcpTable->table[i].dwRemotePort);
            		dest_port = *(p+0)*256 + *(p+1);
			if(*dest_ip==0)
                    	dest_port = 0;
			
			buffer = (char *)malloc(20 * sizeof(char));
			memset(buffer, 0x0, 20 * sizeof(char));

			sprintf(buffer, "%d.%d.%d.%d", *(local_ip+0), *(local_ip+1), *(local_ip+2), *(local_ip+3));
			fprintf(stdout, "%16s", buffer);
			fprintf(stdout, "   %5d", local_port);
			sprintf(buffer, "\t%d.%d.%d.%d", *(dest_ip+0), *(dest_ip+1), *(dest_ip+2), *(dest_ip+3));
			fprintf(stdout, "%-16s", buffer);
			fprintf(stdout, "   %d\t\t%s\n", dest_port, DisplayTcpState(TcpTable->table[i].dwState));

			free(buffer);
		}
	}
	else
		fprintf(stdout, "Error: %d\n", GetLastError());

	free(TcpTable);

	return(0);
}


int GetAndDisplayUdpTable(void)
{
	PMIB_UDPTABLE UdpTable;
	unsigned long pdwSize;
	unsigned int i, local_port;
	unsigned char *p = NULL, *local_ip = NULL;
	char *buffer = NULL;

	pdwSize = GetUdpTable(NULL, &pdwSize, TRUE);
	pdwSize = (pdwSize + 1) * sizeof(MIB_TCPTABLE) ;
	UdpTable = (PMIB_UDPTABLE)malloc(pdwSize * sizeof(UdpTable));

	if(GetUdpTable(UdpTable, &pdwSize, TRUE) == NO_ERROR)
	{
		fprintf(stdout, "=============\n");
		fprintf(stdout, "= UDP Table =\n");
		fprintf(stdout, "=============\n\n");
		fprintf(stdout, "=> Number of entries : %d\n\n", UdpTable->dwNumEntries);
		
		for(i=0; i < UdpTable->dwNumEntries; i++)
		{
			local_ip = (unsigned char *)&(UdpTable->table[i].dwLocalAddr);
			p = (unsigned char * )&(UdpTable->table[i].dwLocalPort);
			local_port = *(p+0)*256 + *(p+1);		
			
			buffer = (char *)malloc(25 * sizeof(char));
			memset(buffer, 0x0, 25 * sizeof(char));

			wsprintf(buffer," %d.%d.%d.%d:%d\n", *(local_ip+0), *(local_ip+1), *(local_ip+2), *(local_ip+3), local_port);
			
			fprintf(stdout, "%25s", buffer);
			free(buffer);
		}
	}
	else
		fprintf(stdout, "Error: %d\n", GetLastError());

	free(UdpTable);

	return(0);
}


int GetAndDisplayIpAddrTable(void)
{
	PMIB_IPADDRTABLE IpAddrTable;
	struct in_addr addr;
	unsigned long pdwSize;
	unsigned int i;

	pdwSize = GetIpAddrTable(NULL, &pdwSize, TRUE);
	pdwSize = (pdwSize + 1) * sizeof(MIB_IPADDRTABLE) ;
	IpAddrTable = (PMIB_IPADDRTABLE)malloc(pdwSize * sizeof(IpAddrTable));

	if(GetIpAddrTable(IpAddrTable, &pdwSize, TRUE) == NO_ERROR)	
	{
		fprintf(stdout, "=========================================\n");
		fprintf(stdout, "= INTERFACE TO IP ADDRESS MAPPING TABLE =\n");
		fprintf(stdout, "=========================================\n\n");
		fprintf(stdout, "=> Number of entries : %d\n\n", IpAddrTable->dwNumEntries);
		
		for(i=0 ; i < IpAddrTable->dwNumEntries ; i++)
		{ 
				 fprintf(stdout, "- Entry %d :\n\n", i+1);

                 fprintf(stdout, " => Index\t\t0x%8.8x\n", (int)IpAddrTable->table[i].dwIndex);
 
                 addr.S_un.S_addr = IpAddrTable->table[i].dwAddr;
                 fprintf(stdout, " => Address\t\t%s\n", inet_ntoa(addr));

                 addr.S_un.S_addr = IpAddrTable->table[i].dwMask;
                 fprintf(stdout, " => Mask\t\t%s\n", inet_ntoa(addr));
 
                 addr.S_un.S_addr = IpAddrTable->table[i].dwBCastAddr;
                 fprintf(stdout, " => Broadcast Address\t%s\n", inet_ntoa(addr));
 
                 fprintf(stdout, " => ReasmSize\t\t%d\n\n", IpAddrTable->table[i].dwReasmSize);
 	    }
	}
	else
		fprintf(stdout, "Error: %d\n", GetLastError());

	free(IpAddrTable);

	return(0);
}




int GetAndDisplayIpForwardTable(void)
{
	PMIB_IPFORWARDTABLE IpForwardTable;
	struct protoent *protocol = NULL;
	unsigned long pdwSize;
	unsigned char *forward_ip = NULL, *subnet_ip = NULL, *ip_hop = NULL;
	unsigned int i;
	char *buffer;

	pdwSize = GetIpForwardTable(NULL, &pdwSize, TRUE);
	pdwSize = (pdwSize + 1) * sizeof(MIB_IPFORWARDTABLE) ;
	IpForwardTable = (PMIB_IPFORWARDTABLE)malloc(pdwSize * sizeof(IpForwardTable));
	
	if(GetIpForwardTable(IpForwardTable, &pdwSize, TRUE) == NO_ERROR)	
	{
		fprintf(stdout, "====================\n");
		fprintf(stdout, "= IP ROUTING TABLE =\n");
		fprintf(stdout, "====================\n\n");
		fprintf(stdout, "=> Number of entries : %d\n", IpForwardTable->dwNumEntries);
		fprintf(stdout, "==============================================================================\n");
		fprintf(stdout, "Destination reseau    Masque reseau     Adr. passerelle   Interface   Metrique\n");
		fprintf(stdout, "==============================================================================\n");
				
		for(i=0 ; i < IpForwardTable->dwNumEntries ; i++)
		{ 
			 forward_ip = (unsigned char *)&(IpForwardTable->table[i].dwForwardDest);
			 subnet_ip = (unsigned char *)&(IpForwardTable->table[i].dwForwardMask);
			 ip_hop = (unsigned char *)&(IpForwardTable->table[i].dwForwardNextHop);

			 buffer = (char *)malloc(20 * sizeof(char));

			 sprintf(buffer, "%d.%d.%d.%d", *(forward_ip+0), *(forward_ip+1), *(forward_ip+2), *(forward_ip+3));
			 fprintf(stdout, "%16s", buffer);			 
			 sprintf(buffer, "%d.%d.%d.%d", *(subnet_ip+0), *(subnet_ip+1), *(subnet_ip+2), *(subnet_ip+3));
			 fprintf(stdout, "   %16s", buffer);
			 sprintf(buffer, "%d.%d.%d.%d", *(ip_hop+0), *(ip_hop+1), *(ip_hop+2), *(ip_hop+3));
			 fprintf(stdout, "   %16s", buffer);
			 fprintf(stdout, "   0x%8.8x", IpForwardTable->table[i].dwForwardIfIndex);
			 fprintf(stdout, "   %d\n", IpForwardTable->table[i].dwForwardMetric1);
			 free(buffer);
		}
	}
	else
		fprintf(stdout, "Error: %d\n", GetLastError());
	

	free(IpForwardTable);

	return(0);
}